setwd("<YOUR_DIRECTORY>")


### READ DATA ###
a <- read.csv(file="data/global_a_line_count_so-data_cb.csv", header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE) 
#a_2_9 <- read.csv(file="data/global_a_line_count_2-9_so-data.csv", header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE) 
#a_10 <- read.csv(file="data/global_a_line_count_10_so-data.csv", header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)

a_2_9 <- a[a$line_count>1 & a$line_count<=9,]
a_10 <- a[a$line_count>9,]

### CLEAN DATA ###
# delete currupted rows
nrow(a)
# 14490
a <- a[!is.na(a$question_title),]
nrow(a)
# 14403
nrow(a_2_9)
# 3160
a_2_9 <- a_2_9[!is.na(a_2_9$question_title),]
nrow(a_2_9)
# 3135
nrow(a_10)
# 122
a_10 <- a_10[!is.na(a_10$question_title),]
nrow(a_10)
# 122
# if owner has no reputation, it is NA => set it to 0
if (nrow(a[is.na(a$question_owner_reputation),])>0) {
  a[is.na(a$question_owner_reputation),]$question_owner_reputation <- 0  
}
if (nrow(a_2_9[is.na(a_2_9$question_owner_reputation),])>0) {
    a_2_9[is.na(a_2_9$question_owner_reputation),]$question_owner_reputation <- 0  
}
if (nrow(a_10[is.na(a_10$question_owner_reputation),])>0) {
    a_10[is.na(a_10$question_owner_reputation),]$question_owner_reputation <- 0  
}
if (nrow(a[is.na(a$answer_owner_reputation),])>0) {
  a[is.na(a$answer_owner_reputation),]$answer_owner_reputation <- 0 
}
if (nrow(a_2_9[is.na(a_2_9$answer_owner_reputation),])>0) {
    a_2_9[is.na(a_2_9$answer_owner_reputation),]$answer_owner_reputation <- 0 
}
if (nrow(a_10[is.na(a_10$answer_owner_reputation),])) {
    a_10[is.na(a_10$answer_owner_reputation),]$answer_owner_reputation <- 0  
}
# assign age to questions
now <- as.POSIXct("2016-08-01 UTC", tz="UTC", origin="1970-01-01")
a$question_creation_date <- as.POSIXct(a$question_creation_date, tz="UTC", origin="1970-01-01")
question_age <- difftime(now, a$question_creation_date, units="days")
a[["question_age"]] <- question_age
a_2_9$question_creation_date <- as.POSIXct(a_2_9$question_creation_date, tz="UTC", origin="1970-01-01")
question_age <- difftime(now, a_2_9$question_creation_date, units="days")
a_2_9[["question_age"]] <- question_age
a_10$question_creation_date <- as.POSIXct(a_10$question_creation_date, tz="UTC", origin="1970-01-01")
question_age <- difftime(now, a_10$question_creation_date, units="days")
a_10[["question_age"]] <- question_age
# assign age to answers
a$answer_creation_date <- as.POSIXct(a$answer_creation_date, tz="UTC", origin="1970-01-01")
answer_age <- difftime(now, a$answer_creation_date, units="days")
a[["answer_age"]] <- answer_age
a_2_9$answer_creation_date <- as.POSIXct(a_2_9$answer_creation_date, tz="UTC", origin="1970-01-01")
answer_age <- difftime(now, a_2_9$answer_creation_date, units="days")
a_2_9[["answer_age"]] <- answer_age
a_10$answer_creation_date <- as.POSIXct(a_10$answer_creation_date, tz="UTC", origin="1970-01-01")
answer_age <- difftime(now, a_10$answer_creation_date, units="days")
a_10[["answer_age"]] <- answer_age

length(which(a$line_count==1))
# 11146
11146/nrow(a)*100
# 77.38666

summary(a$line_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1.000   1.000   1.000   1.552   1.000 136.000 
summary(a_10$line_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 10.00   12.00   14.00   19.35   21.00  136.00 
summary(a_2_9$line_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 2.000   2.000   2.000   2.821   3.000   9.000 
table(a_2_9$line_count)

barplot(table(a$line_count))
barplot(table(a_2_9$line_count))
barplot(table(a_10$line_count))

library(scales)  # for color transparency (alpha) 

d_2_9 <- density(a_2_9$question_view_count) 
d_10 <- density(a_10$question_view_count)
plot(d_2_9)
lines(d_10)
polygon(d_10, col=alpha("gray90", 0.5), border="black")
polygon(d_2_9, col=alpha("gray70", 0.5), border="black")

d_2_9 <- density(a_2_9$question_score) 
d_10 <- density(a_10$question_score)
plot(d_2_9)
lines(d_10)
polygon(d_10, col=alpha("gray90", 0.5), border="black")
polygon(d_2_9, col=alpha("gray70", 0.5), border="black")

d_2_9 <- density(a_2_9$answer_score) 
d_10 <- density(a_10$answer_score)
plot(d_2_9)
lines(d_10)
polygon(d_10, col=alpha("gray90", 0.5), border="black")
polygon(d_2_9, col=alpha("gray70", 0.5), border="black")

d_2_9 <- density(as.numeric(a_2_9$question_age)) 
d_10 <- density(as.numeric(a_10$question_age))
plot(d_10)
lines(d_2_9)
polygon(d_10, col=alpha("gray90", 0.5), border="black")
polygon(d_2_9, col=alpha("gray70", 0.5), border="black")

d_2_9 <- density(as.numeric(a_2_9$answer_age)) 
d_10 <- density(as.numeric(a_10$answer_age))
plot(d_10)
lines(d_2_9)
polygon(d_10, col=alpha("gray90", 0.5), border="black")
polygon(d_2_9, col=alpha("gray70", 0.5), border="black")

library(vioplot)

pdf("figures/violin_a_global.pdf", bg="transparent", width=7, height=9)
par(
    mar = c(2.5, 1.5, 1.5, 1.5)+0.1, # subplot margins (bottom, left, top, right)
    omi = c(0.2, 0.2, 0.2, 0.2),  # outer margins in inches (bottom, left, top, right)
    #mfrow = c(2, 2)
    #pin = (width, height)
    #mfcol # draw in columns
    # increase font size
    cex.main=1.6,
    cex.lab=1.6,
    cex.axis=1.6
)
layout(matrix(c(1,2,3,4,5,5), 3, 2, byrow = TRUE))

vioplot(a_2_9$answer_score,
        a_10$answer_score,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c("2-9 refs", ">9 refs"), ylim=c(0, 0.5*max(a_10$question_score)))  # use same limits as question score
#lines(data.frame(c(1, 2), c(median(a_10$answer_score), median(a_10$answer_score))), lty=3)
abline(v=median(a_10$answer_score), lty=3)
title("Answer score")

vioplot(a_2_9$answer_age/365,
        a_10$answer_age/365,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c("2-9 refs", ">9 refs"), ylim=c(0, max(a_10$question_age/365)))  # use same limits as question age
#lines(data.frame(c(1, 2), c(median(a_10$answer_age/365), median(a_10$answer_age/365))), lty=3)
abline(v=median(a_10$answer_age/365), lty=3)
title("Answer age (years)")

vioplot(a_2_9$question_score,
        a_10$question_score,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c("2-9 refs", ">9 refs"), ylim=c(0, 0.5*max(a_10$question_score)))
#lines(data.frame(c(1, 2), c(median(a_10$question_score), median(a_10$question_score))), lty=3)
abline(v=median(a_10$question_score), lty=3)
title("Question score")

vioplot(a_2_9$question_age/365,
        a_10$question_age/365,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c("2-9 refs", ">9 refs"), ylim=c(0, max(a_10$question_age/365)))
#lines(data.frame(c(1, 2), c(median(a_10$question_age/365), median(a_10$question_age/365))), lty=3)
abline(v=median(a_10$question_age/365), lty=3)
title("Question age (years)")

vioplot(a_2_9$question_view_count,
        a_10$question_view_count,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c("2-9 refs", ">9 refs"), ylim=c(0, 0.5*max(a_10$question_view_count)))
#lines(data.frame(c(1, 2), c(median(a_10$question_view_count), median(a_10$question_view_count))), lty=3)
abline(v=median(a_10$question_view_count), lty=3)
title("Question view count")

#par(mfrow = c(1, 1))
dev.off() 

pdf("figures/violin_a_global_score_viewcount.pdf", bg="transparent", width=10, height=4)
par(
    mar = c(1.5, 2.5, 1.5, 0.5)+0.1, # subplot margins (bottom, left, top, right)
    omi = c(0.1, 0.0, 0.0, 0.0),  # outer margins in inches (bottom, left, top, right)
    #mfrow = c(2, 2)
    #pin = (width, height)
    #mfcol # draw in columns
    # increase font size
    cex.main=1.6,
    cex.lab=1.6,
    cex.axis=1.6
)
layout(matrix(c(1,2), 1, 2, byrow = TRUE))

vioplot(a_2_9$answer_score,
        a_10$answer_score,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c("2-9 refs", ">9 refs"), ylim=c(0, 0.5*max(a_10$question_score)))  # use same limits as question score
#lines(data.frame(c(1, 2), c(median(a_10$answer_score), median(a_10$answer_score))), lty=3)
abline(v=median(a_10$answer_score), lty=3)
title("Answer score")

vioplot(a_2_9$question_view_count,
        a_10$question_view_count,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c("2-9 refs", ">9 refs"), ylim=c(0, 0.5*max(a_10$question_view_count)))
#lines(data.frame(c(1, 2), c(median(a_10$question_view_count), median(a_10$question_view_count))), lty=3)
abline(v=median(a_10$question_view_count), lty=3)
title("Question view count")

#par(mfrow = c(1, 1))
dev.off() 


### T-TEST ###
# http://stats.stackexchange.com/questions/31326/how-should-one-interpret-the-comparison-of-means-from-different-sample-sizes/31330#31330
# http://stats.stackexchange.com/questions/82705/unequal-sample-sizes-when-to-call-it-quits
#t.test(a_10$question_view_count, a_2_9$question_view_count, alternative="greater", paired=FALSE, conf.level=0.99, var.equal=FALSE)
# http://math.stackexchange.com/questions/625359/how-are-the-values-in-the-shapiro-wilk-weight-table-calculated
# http://stats.stackexchange.com/questions/15696/interpretation-of-shapiro-wilk-test/15702#15702
# http://www.r-bloggers.com/normality-tests-don%E2%80%99t-do-what-you-think-they-do/
# http://stackoverflow.com/questions/15427692/perform-a-shapiro-wilk-normality-test/15427746#15427746
# http://stackoverflow.com/questions/7781798/seeing-if-data-is-normally-distributed-in-r/7788452#7788452
#shapiro.test(a_10$question_view_count)
#shapiro.test(a_2_9$question_view_count)

### WILCOXON TEST AND EFFECT SIZE ###
library(effsize)

summary(a_10$question_view_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1666   52820  155600  304600  357700 2094000
sd(a_10$question_view_count)
# 409133.1
summary(a_2_9$question_view_count)
# Min. 1st Qu.  Median  Mean 3rd Qu.    Max. 
# 30    9558   32780  105100  111800 3141000 
sd(a_2_9$question_view_count)
# 210639.9
wilcox.test(a_10$question_view_count, a_2_9$question_view_count, alternative="greater", paired=F, correct=T) # Wilcoxon rank sum test (equivalent to the Mann-Whitney test), exact distribution (Streitberg-Roehmel algorithm) => handles ties
# W = 286212, p-value < 2.2e-16
# alternative hypothesis: true location shift is greater than 0
median(a_10$question_view_count)-median(a_2_9$question_view_count)
cliff.delta(a_10$question_view_count, a_2_9$question_view_count)
# delta estimate: 0.4966507 (large)
# 95 percent confidence interval:
#   inf       sup 
# 0.4109702 0.5736342 


summary(a_10$question_score)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 3.00   99.75  224.50  520.80  546.00 2981.00
sd(a_10$question_score)
# 693.8418
summary(a_2_9$question_score)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# -2.0    15.0    45.0   154.7   140.0  5145.0
sd(a_2_9$question_score)
# 357.3775
wilcox.test(a_10$question_score, a_2_9$question_score, alternative="greater", paired=F, correct=T) # Wilcoxon rank sum test (equivalent to the Mann-Whitney test), exact distribution (Streitberg-Roehmel algorithm) => handles ties
# W = 293816.5, p-value < 2.2e-16
# alternative hypothesis: true location shift is greater than 0
median(a_10$question_score)-median(a_2_9$question_score)
cliff.delta(a_10$question_score, a_2_9$question_score)
# delta estimate: 0.5364159 (large)
# 95 percent confidence interval:
#   inf       sup 
# 0.4488878 0.6137486 

summary(a_10$answer_score)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 3.0   104.2   286.0   557.8   679.8  5096.0 
sd(a_10$answer_score)
# 754.3378
summary(a_2_9$answer_score)
# Min. 1st Qu.  Median    Mean  3rd Qu.    Max. 
# -2.0    15.0    43.0   142.9   128.0  7883.0 
sd(a_2_9$answer_score)
# 373.5758
wilcox.test(a_10$answer_score, a_2_9$answer_score, alternative="greater", paired=F, correct=T) # Wilcoxon rank sum test (equivalent to the Mann-Whitney test), exact distribution (Streitberg-Roehmel algorithm) => handles ties
# W = 308273, p-value < 2.2e-16
# alternative hypothesis: true location shift is greater than 0
median(a_10$answer_score)-median(a_2_9$answer_score)
cliff.delta(a_10$answer_score, a_2_9$answer_score)
# delta estimate: 0.6120114 (large)
# 95 percent confidence interval:
#   inf       sup 
# 0.5315838 0.6815012 

summary(as.numeric(a_10$question_age)/365)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 0.6506  5.5140  6.9440  6.3480  7.5240  7.9870 
sd(as.numeric(a_10$question_age)/365)
# 1.51004
summary(as.numeric(a_2_9$question_age/365))
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 0.3513  4.3610  5.7020  5.5380  6.9930  8.0060
sd(as.numeric(a_2_9$question_age)/365)
# 1.686082
wilcox.test(as.numeric(a_10$question_age)/365, as.numeric(a_2_9$question_age)/365, alternative="greater", paired=F, correct=T) # Wilcoxon rank sum test (equivalent to the Mann-Whitney test), exact distribution (Streitberg-Roehmel algorithm) => handles ties
# W = 248752, p-value = 8.293e-09
# alternative hypothesis: true location shift is greater than 0
median(as.numeric(a_10$question_age)/365)-median(as.numeric(a_2_9$question_age)/365)
cliff.delta(a_10$question_age/365, a_2_9$question_age/365)
# delta estimate: 0.3007661 (small)
# 95 percent confidence interval:
#   inf       sup 
# 0.2014178 0.3939891 

summary(as.numeric(a_10$answer_age)/365)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 0.6506  4.3570  5.8380  5.5860  7.1080  7.9830 
sd(as.numeric(a_10$answer_age)/365)
# 1.716591
summary(as.numeric(a_2_9$answer_age)/365)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 0.3433  3.4240  4.7800  4.7950  6.2270  8.0040
sd(as.numeric(a_2_9$answer_age)/365)
# 1.777256
wilcox.test(as.numeric(a_10$answer_age)/365, as.numeric(a_2_9$answer_age)/365, alternative="greater", paired=F, correct=T) # Wilcoxon rank sum test (equivalent to the Mann-Whitney test), exact distribution (Streitberg-Roehmel algorithm) => handles ties
# W = 240803.5, p-value = 5.744e-07
# alternative hypothesis: true location shift is greater than 0
median(as.numeric(a_10$answer_age)/365)-median(as.numeric(a_2_9$answer_age)/365)
cliff.delta(a_10$answer_age/365, a_2_9$answer_age/365)
# delta estimate: 0.259202 (small)
# 95 percent confidence interval:
#   inf       sup 
# 0.1564962 0.3563622


# Correlations
library(corrgram)
corr_vars_a <- a[,c(3, 8, 11, 23, 33, 34)]
corr_vars_a$question_age <- as.numeric(corr_vars_a$question_age)
corr_vars_a$answer_age <- as.numeric(corr_vars_a$answer_age)
corrgram(corr_vars_a, order=FALSE, lower.panel=panel.shade, upper.panel=panel.conf, cor.method="spearman")

corr_vars_a_10 <- a_10[,c(3, 8, 11, 23, 33, 34)]
corr_vars_a_10$question_age <- as.numeric(corr_vars_a_10$question_age)
corr_vars_a_10$answer_age <- as.numeric(corr_vars_a_10$answer_age)
corrgram(corr_vars_a_10, order=FALSE, lower.panel=panel.shade, upper.panel=panel.conf, cor.method="spearman")

corr_vars_a_2_9 <- a_2_9[,c(3, 8, 11, 23, 33, 34)]
corr_vars_a_2_9$question_age <- as.numeric(corr_vars_a_2_9$question_age)
corr_vars_a_2_9$answer_age <- as.numeric(corr_vars_a_2_9$answer_age)
corrgram(corr_vars_a_2_9, order=FALSE, lower.panel=panel.shade, upper.panel=panel.conf, cor.method="spearman")

corr_vars_a_10_age_norm <- corr_vars_a_10
corr_vars_a_10_age_norm$question_view_count <- corr_vars_a_10$question_view_count/corr_vars_a_10$question_age
corr_vars_a_10_age_norm$question_score <- corr_vars_a_10$question_score/corr_vars_a_10$question_age
corr_vars_a_10_age_norm$answer_score <- corr_vars_a_10$answer_score/corr_vars_a_10$answer_age
corrgram(corr_vars_a_10_age_norm, order=FALSE, lower.panel=panel.shade, upper.panel=panel.conf, cor.method="spearman")

corr_vars_a_2_9_age_norm <- corr_vars_a_2_9
corr_vars_a_2_9_age_norm$question_view_count <- corr_vars_a_2_9$question_view_count/corr_vars_a_2_9$question_age
corr_vars_a_2_9_age_norm$question_score <- corr_vars_a_2_9$question_score/corr_vars_a_2_9$question_age
corr_vars_a_2_9_age_norm$answer_score <- corr_vars_a_2_9$answer_score/corr_vars_a_2_9$answer_age
corrgram(corr_vars_a_2_9_age_norm, order=FALSE, lower.panel=panel.shade, upper.panel=panel.conf, cor.method="spearman")

get_cor_p_values <- function(df) {
  result <- data.frame(matrix(ncol=ncol(df), nrow=ncol(df)))
  if (ncol(df) < 2) {
    return(result)
  }
  names(result) <- names(df)
  row.names(result) <- names(df)
  for (i in 1:ncol(df)) {
    for (j in 2:ncol(df)) {
      if (i==j) {
        result[i,j] <- NA  
      } else {
        result[i,j] <- cor.test(df[,i], df[,j], alternative="two.sided", method="spearman", exact=FALSE)$p.value
        result[j,i] <- result[i,j]
      }
    }
  }
  return(result)
} 

get_cor_n <- function(df) {
  result <- data.frame(matrix(ncol=ncol(df), nrow=ncol(df)))
  if (ncol(df) < 2) {
    return(result)
  }
  names(result) <- names(df)
  row.names(result) <- names(df)
  for (i in 1:ncol(df)) {
    for (j in 2:ncol(df)) {
      if (i==j) {
        result[i,j] <- NA  
      } else {
        comp_cases <- complete.cases(cbind(df[,i], df[,j]))
        result[i,j] <- length(comp_cases[comp_cases==TRUE])
        result[j,i] <- result[i,j]
      }
    }
  }
  return(result)
}

cor(corr_vars_a, use="pairwise.complete.obs", method="spearman")
#                      line_count question_view_count question_score answer_score question_age answer_age
# line_count           1.0000000           0.2142042      0.2411940    0.2728160    0.1598316  0.1375022
# question_view_count  0.2142042           1.0000000      0.8944314    0.7170442    0.5446407  0.3438671
# question_score       0.2411940           0.8944314      1.0000000    0.7637091    0.5358808  0.3321315
# answer_score         0.2728160           0.7170442      0.7637091    1.0000000    0.3837888  0.4206499
# question_age         0.1598316           0.5446407      0.5358808    0.3837888    1.0000000  0.7523296
# answer_age           0.1375022           0.3438671      0.3321315    0.4206499    0.7523296  1.0000000
get_cor_p_values(corr_vars_a)
#                      line_count question_view_count question_score  answer_score question_age   answer_age
# line_count                     NA       4.087097e-149  1.032606e-189 3.321369e-244 4.937503e-83 9.828854e-62
# question_view_count 4.087097e-149                  NA   0.000000e+00  0.000000e+00 0.000000e+00 0.000000e+00
# question_score      1.032606e-189        0.000000e+00             NA  0.000000e+00 0.000000e+00 0.000000e+00
# answer_score        3.321369e-244        0.000000e+00   0.000000e+00            NA 0.000000e+00 0.000000e+00
# question_age         4.937503e-83        0.000000e+00   0.000000e+00  0.000000e+00           NA 0.000000e+00
# answer_age           9.828854e-62        0.000000e+00   0.000000e+00  0.000000e+00 0.000000e+00           NA
get_cor_n(corr_vars_a)
#                      line_count question_view_count question_score answer_score question_age answer_age
# line_count                  NA               14403          14403        14403        14403      14403
# question_view_count      14403                  NA          14403        14403        14403      14403
# question_score           14403               14403             NA        14403        14403      14403
# answer_score             14403               14403          14403           NA        14403      14403
# question_age             14403               14403          14403        14403           NA      14403
# answer_age               14403               14403          14403        14403        14403         NA


# see http://stats.stackexchange.com/a/70807, http://stats.stackexchange.com/a/180249, http://stackoverflow.com/a/15779107
normalize <- function(x, min_x, max_x) {
    return ((x-min_x) / (max_x-min_x))
}
normalize_df <- function(df) {
    result <- NULL
    for (i in names(df)) {
        min_i <- min(df[,i])
        max_i <- max(df[,i])
        norm_i <- unlist(as.numeric(lapply(df[,i], function(x) {
            normalize(x, min_i, max_i)
        })))
        if (is.null(result)) {
            result <- norm_i
        } else {
            result <- cbind(result, norm_i)
        }
    }
    result <- data.frame(result)
    names(result) <- names(df)
    return(result)
}

library(car)
corr_vars_a_10_norm <- normalize_df(corr_vars_a_10)
scatterplotMatrix(~corr_vars_a_10_norm$line_count+corr_vars_a_10_norm$question_view_count+corr_vars_a_10_norm$question_score+corr_vars_a_10_norm$answer_score+corr_vars_a_10_norm$question_age+corr_vars_a_10_norm$answer_age, data=corr_vars_a_10_norm)

corr_vars_a_2_9_norm <- normalize_df(corr_vars_a_2_9)
scatterplotMatrix(~corr_vars_a_2_9_norm$line_count+corr_vars_a_2_9_norm$question_view_count+corr_vars_a_2_9_norm$question_score+corr_vars_a_2_9_norm$answer_score+corr_vars_a_2_9_norm$question_age+corr_vars_a_2_9_norm$answer_age, data=corr_vars_a_2_9_norm)

plot(corr_vars_a_10$line_count, corr_vars_a_10$question_score)
nrow(corr_vars_a_10)
corr_vars_a_10_new <- corr_vars_a_10[corr_vars_a_10$line_count<=60,]
nrow(corr_vars_a_10_new)
plot(corr_vars_a_10_new$line_count, corr_vars_a_10_new$question_score)

corr_vars_a_10_new_norm <- normalize_df(corr_vars_a_10_new)
fitted_model <- lm(corr_vars_a_10_new_norm$line_count~corr_vars_a_10_new_norm$question_score)
summary(fitted_model)
plot(corr_vars_a_10_new_norm$line_count, corr_vars_a_10_new_norm$question_score)
abline(fitted_model, col="red")

plot(corr_vars_a_2_9$line_count, corr_vars_a_2_9$question_score)
corr_vars_a_2_9_norm <- normalize_df(corr_vars_a_2_9)
fitted_model <- lm(corr_vars_a_2_9_norm$line_count~corr_vars_a_2_9_norm$question_score)
summary(fitted_model)
plot(corr_vars_a_2_9_norm$line_count, corr_vars_a_2_9_norm$question_score)
abline(fitted_model, col="red")

# answer age
summary(as.numeric(a$answer_age)/365)
# Min.    1st Qu. Median  Mean    3rd Qu. Max. 
# 0.05035 2.97500 4.30300 4.36800 5.77900 8.00400 

vioplot(a$answer_age/365,
        col="gray90", pchMed=4, rectCol="white", colMed="black", horizontal=TRUE, wex=1.15,
        names=c(""), ylim=c(0, max(a$question_age/365)))  # use same limits as question age
abline(v=mean(a$answer_age/365), lty=3)
title("Answer age (years)")

# DISPERSION OF VALUES
# see http://stackoverflow.com/a/12867538 and https://en.wikipedia.org/wiki/Outlier#Tukey.27s_test
outliers <- function(v, k) { # k=1.5 or k=3 typical, see Tukey test
  q_1 = quantile(v)[2]
  q_3 = quantile(v)[4]
  iqr = q_3-q_1
  lower_threshold = q_1 - k*iqr
  upper_threshold = q_3 + k*iqr
  return(v[v<lower_threshold | v>upper_threshold])
}

outliers_percent <- function(v, k) { # k=1.5 or k=3 typical, see Tukey test
  return(length(outliers(v, k))/length(v)*100)
}

outliers_percent(a$question_view_count, 1.5)
# 11.85864
outliers_percent(a$question_view_count, 3)
# 6.852739

outliers_percent(a$question_score, 1.5)
# 12.62237
outliers_percent(a$question_score, 3)
# 7.921961

outliers_percent(a$answer_score, 1.5)
# 12.42797
outliers_percent(a$answer_score, 3)
# 7.727557

outliers_percent(a$question_age, 1.5)
# 0
outliers_percent(a$question_age, 3)
# 0

outliers_percent(a$answer_age, 1.5)
# 0
outliers_percent(a$answer_age, 3)
# 0


# analysis of code blocks

extracted_values <- lapply(a$answer_code_blocks, function(x) {
  length_values = trimws(unlist(strsplit(x, '//', fixed=TRUE)))
  if (length(length_values)>0) {
    # first element is number of code blocks and total length
    head = trimws(unlist(strsplit(length_values[1], '-', fixed=TRUE)))
    if (length(length_values)>1) {
      return(c(head, length_values[2:length(length_values)]))  
    } else {
      return(head)
    }
  } else {
    return(character(0))
  }
})

code_block_count <- unlist(lapply(extracted_values, function(x) {
  as.integer(x[1])
}))

code_block_length <- unlist(lapply(extracted_values, function(x) {
  as.integer(x[2])
}))

code_block_list <- lapply(extracted_values, function(x) {
  values <- x[3:length(x)]
  values <- as.integer(values)
  values[match(character(0), values)] <- NA 
  values[match(0, values)] <- NA
  values
})

sort(table(unlist(code_block_list)), decreasing=TRUE)[1:20]

values <- unlist(code_block_list)
d <- density(na.omit(values[values<=100]))
plot(d)

# remove code blocks with less than 50 charcters (likely used only for markup)
code_block_list_50 <- lapply(code_block_list, function(x) {
  values <- unlist(x)
  result <- values[!anyNA(values) & values>=50]
  if (length(result)>0) {
    result
  } else {
    NA
  }
})

nas_empty <- unlist(lapply(code_block_list, function(x) {
  anyNA(x) | (0 %in% x)
}))

# elements without code blocks
length(code_block_list)
# 14403
length(code_block_list[nas_empty])
# 539
(1-(539/14403))*100
# 96.25772
539/14403*100
# 3.742276

a$has_code_block <- !nas_empty
a$code_block_50_length <- unlist(lapply(code_block_list_50, sum))
a$code_block_50_count <- unlist(lapply(code_block_list_50, function(x) {
  length(x)
}))

# elements without code blocks that are longer than 50 characters
length(code_block_list_50)
# 14403
length(a$code_block_50_length[is.na(a$code_block_50_length)])
# 1581
(1-(1581/14403))*100
# 89.02312
1581/14403*100
# 10.97688

a_1_cb <- a[a$line_count==1,]
a_2_9_cb <- a[a$line_count>1 & a$line_count<=9,]
a_10_cb <- a[a$line_count>9,]

table(a_1_cb$has_code_block)
# FALSE  TRUE 
# 461 10685 
(1-(461/10685))*100
# 95.68554
table(a_2_9_cb$has_code_block)
# FALSE  TRUE 
# 77  3058 
(1-(77/3058))*100
# 97.48201
table(a_10_cb$has_code_block)
# FALSE  TRUE 
# 1   121 
(1-(1/121))*100
# 99.17355

summary(a_1_cb$code_block_50_length)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max.    NA's 
#   50.0   242.0   519.0   967.2  1061.0 25590.0    1338 
summary(a_2_9_cb$code_block_50_length)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max.    NA's 
#   50.0   293.2   581.0  1100.0  1210.0 26300.0     241 
summary(a_10_cb$code_block_50_length)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max.    NA's 
#   56.0   282.2   573.5   996.8  1133.0 10640.0       2 

summary(a_1_cb$code_block_50_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1.000   1.000   1.000   1.687   2.000  24.000 
summary(a_2_9_cb$code_block_50_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1.00    1.00    1.00    1.84    2.00   26.00 
summary(a_10_cb$code_block_50_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1.000   1.000   2.000   2.516   3.000  24.000 

library(scales)  # for color transparency (alpha) 
d_1 <- density(na.omit(a_1_cb$code_block_50_length[a_1_cb$code_block_50_length<=3000])) 
d_2_9 <- density(na.omit(a_2_9_cb$code_block_50_length[a_1_cb$code_block_50_length<=3000])) 
d_10 <- density(na.omit(a_10_cb$code_block_50_length[a_1_cb$code_block_50_length<=3000]))
plot(d_1)
lines(d_2_9)
lines(d_10)
polygon(d_1, col=alpha("gray100", 0.5), border="black")
polygon(d_2_9, col=alpha("gray90", 0.5), border="black")
polygon(d_10, col=alpha("gray80", 0.5), border="black")

summary(a_10_cb$code_block_50_length)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max.    NA's 
#   56.0   282.2   573.5   996.8  1133.0 10640.0       2 
sd(na.omit(a_10_cb$code_block_50_length))
# 1388.92
summary(a_2_9_cb$code_block_50_length)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max.    NA's 
#   50.0   293.2   581.0  1100.0  1210.0 26300.0     241 
sd(na.omit(a_2_9_cb$code_block_50_length))
# 1852.915
wilcox.test(a_10_cb$code_block_50_length, a_2_9_cb$code_block_50_length, alternative="greater", paired=F, correct=T) # Wilcoxon rank sum test (equivalent to the Mann-Whitney test), exact distribution (Streitberg-Roehmel algorithm) => handles ties
# W = 172660, p-value = 0.542
# alternative hypothesis: true location shift is greater than 0
median(na.omit(a_10_cb$code_block_50_length))-median(na.omit(a_2_9_cb$code_block_50_length))
library(effsize)
cliff.delta(a_10_cb$code_block_50_length, a_2_9_cb$code_block_50_length)
# delta estimate: -0.08211058 (negligible)
# 95 percent confidence interval:
#   inf        sup 
# -0.1739275  0.0111217 

summary(a_10_cb$code_block_50_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1.000   1.000   2.000   2.516   3.000  24.000 
sd(na.omit(a_10_cb$code_block_50_count))
# 2.805643
summary(a_2_9_cb$code_block_50_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1.00    1.00    1.00    1.84    2.00   26.00 
sd(na.omit(a_2_9_cb$code_block_50_count))
# 1.634517
wilcox.test(a_10_cb$code_block_50_count, a_2_9_cb$code_block_50_count, alternative="greater", paired=F, correct=T) # Wilcoxon rank sum test (equivalent to the Mann-Whitney test), exact distribution (Streitberg-Roehmel algorithm) => handles ties
# W = 225700, p-value = 7.198e-05
# alternative hypothesis: true location shift is greater than 0
median(na.omit(a_10_cb$code_block_50_count))-median(na.omit(a_2_9_cb$code_block_50_count))
library(effsize)
cliff.delta(a_10_cb$code_block_50_count, a_2_9_cb$code_block_50_count)
# delta estimate: 0.1802233 (small)
# 95 percent confidence interval:
#  inf        sup 
# 0.07927953 0.27750851 

# analysis of individual code blocks
summary(unlist(code_block_list_50))
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max.    NA's 
#  50     120     254     549     572   26300    1581 
sd(na.omit(unlist(code_block_list_50)))
# 1051.631

summary(a$code_block_50_count)
# Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
# 1.000   1.000   1.000   1.727   2.000  26.000
