import logging


def configure_logger(name, log_file):
    """
    see also http://stackoverflow.com/a/7622029
    :param log_file:
    """

    logger = logging.getLogger(name)  # name is None => returns root logger

    log_formatter = logging.Formatter(fmt='%(asctime)s %(name)s %(levelname)s: %(message)s')

    console_handler = logging.StreamHandler()
    console_handler.setFormatter(log_formatter)
    console_handler.setLevel(logging.INFO)

    file_handler = logging.FileHandler(log_file)
    file_handler.setFormatter(log_formatter)
    file_handler.setLevel(logging.DEBUG)

    logger.setLevel(logging.DEBUG)
    logger.addHandler(console_handler)
    logger.addHandler(file_handler)

    return logger
