LANGUAGE=c("java")

setwd("<YOUR_DIRECTORY>")

# read data
java_a_q_line <- read.csv(file=paste("data/", LANGUAGE, "_a_q_distinct_url_line.csv", sep=""), header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)

# get position of answers
answers_pos <- grep('http://stackoverflow.com/a/[^[:space:]]*', java_a_q_line$url, value=FALSE)
# get unique answer URLS
unique_a <- unique(java_a_q_line$url[answers_pos])
# randomly chose one file for each unique answer URL
sampling_frame <- unlist(lapply(unique_a, function(url) {
  url_pos <- which(java_a_q_line$url %in% url)
  # if first argument of sample has length 1, the return value is sample(1:x), not x
  if (length(url_pos)>1) {
    sample(url_pos, 1)  
  } else {
    url_pos  
  }
}))

length(sampling_frame)
# 2443

# draw a sample
sample <- java_a_q_line[sample(sampling_frame, 100),]

# write sample to csv
write.table(sample, file=paste("data/", LANGUAGE, "_a_sample_100.csv", sep=""), sep=",", col.names=TRUE, row.names=FALSE, na="", quote=TRUE, qmethod="double")
