setwd("<YOUR_DIRECTORY>")

# read data
questions <- read.csv(file="java_q_score_viewcount.csv", header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)
answers <- read.csv(file="java_a_score_viewcount.csv", header=TRUE, sep=";", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)

summary(questions)
#        Id               Score             ViewCount      
# Min.   :     123   Min.   :  -39.000   Min.   :      2  
# 1st Qu.:10996058   1st Qu.:    0.000   1st Qu.:     75  
# Median :19892796   Median :    0.000   Median :    228  
# Mean   :19111130   Mean   :    1.716   Mean   :   1812  
# 3rd Qu.:27565338   3rd Qu.:    2.000   3rd Qu.:    894  
# Max.   :34573252   Max.   :13188.000   Max.   :2824364

nrow(questions)
# 987195

length(which(questions$Score<2))
# 734598
734598/987195*100
# 74.41265

length(which(questions$Score<10))
# 959143
959143/987195*100
# 97.15841

nrow(questions[questions$ViewCount<2000,])
# 846086
846086/987195*100
# 85.70607

nrow(questions[questions$ViewCount>=2000,])
# 141108
141108/987195*100
# 14.29383

summary(answers)
#        Id              ParentId           AnswerScore       QuestionScore    QuestionViewCount
# Min.   :     127   Min.   :     123   Min.   :  -38.000   Min.   :  -39.000   Min.   :      4  
# 1st Qu.: 8667202   1st Qu.: 7696423   1st Qu.:    0.000   1st Qu.:    0.000   1st Qu.:    109  
# Median :17158583   Median :15990083   Median :    1.000   Median :    1.000   Median :    424  
# Mean   :17155026   Mean   :16339512   Mean   :    2.276   Mean   :    5.304   Mean   :   5219  
# 3rd Qu.:25604429   3rd Qu.:24692943   3rd Qu.:    2.000   3rd Qu.:    3.000   3rd Qu.:   1946  
# Max.   :34573254   Max.   :34573233   Max.   :18576.000   Max.   :13188.000   Max.   :2824364 

nrow(answers)
# 1777766

# sample size compared to all answers
6959/nrow(answers)*100
# 0.3914463

nrow(answers[answers$AnswerScore>=10,])
# 57978
57978/nrow(answers)*100
# 3.261284

length(which(answers$AnswerScore<10))
# 1719788
1719788/nrow(answers)*100
# 96.73872

