-- Status: 09.08.2016

------------------------------------------------------
--- GET SCORE AND VIEWCOUNT FOR ALL JAVA QUESTIONS ---
------------------------------------------------------
USE stackoverflow16_1;
SELECT Id, Score, ViewCount
FROM posts
WHERE
  PostTypeId=1  #question
  AND Tags LIKE '%<java>%';
  
=> java_q_score_viewcount.csv
  
------------------------------------------------------------------
--- GET SCORE AND CORRESPONDING VIEWCOUNT FOR ALL JAVA ANSWERS ---
------------------------------------------------------------------
USE stackoverflow16_1;

CREATE TABLE java_questions
AS SELECT Id, Score, ViewCount
FROM posts
WHERE
  PostTypeId=1
  AND Tags LIKE '%<java>%';

CREATE INDEX java_questions_1 ON java_questions(Id);

CREATE TABLE answers
AS SELECT Id, ParentId, Score
FROM posts
WHERE PostTypeId=2;

CREATE INDEX answers_index_1 ON answers(Id);
CREATE INDEX answers_index_2 ON answers(ParentId);

CREATE TABLE java_answers_new
AS SELECT a.Id as Id, a.ParentId as ParentId, a.Score as AnswerScore, q.Score as QuestionScore, q.ViewCount as QuestionViewCount
FROM
answers as a
INNER JOIN
java_questions as q
ON a.ParentId = q.Id;

SELECT *
FROM java_answers_new
INTO outfile "java_a_score_viewcount.csv"
FIELDS TERMINATED BY ';'
OPTIONALLY ENCLOSED BY '"'
LINES TERMINATED BY '\n';

=> /var/lib/mysql/stackoverflow16_1/java_a_score_viewcount.csv